#include <stdio.h>
#include <math.h>
#include <GL/glut.H>

float ***vol; //Oz
int num[3]; //{NZ̐
float pitch[3]; //Ŝ̑傫

float bg[3] = {1,1,1}; //wi̐F

float iso = 0.5; //lʂ̒l (㉺L[ŕύX\)

#define DT 1 //sb`̕ς1Ƃ̐ϕ̃XebvTCY

float light[3] = {0,0,1}; //̕
float color[3] = {0.5, 0.5, 1}; //F

//]̂߂̕ϐ
int mouseX, mouseY;
float qw, qx, qy, qz;
float zoom;
float shiftX, shiftY;
int width, height;

//`Ɏg2摜
GLubyte *image;

void readVolume(char* path){
  FILE* in = fopen(path, "r");
  fscanf(in, "%d %d %d", &num[0], &num[1], &num[2]);
  fscanf(in, "%f %f %f", &pitch[0], &pitch[1], &pitch[2]);
  vol = new float**[num[2]];
  float max = 0;
  for(int i=0; i<num[2]; i++){
    vol[i] = new float*[num[1]];
    for(int j=0; j<num[1]; j++){
      vol[i][j] = new float[num[0]];
      for(int k=0; k<num[0]; k++){
        fscanf(in, "%f", &vol[i][j][k]);
        if(max < vol[i][j][k])
          max = vol[i][j][k];
      }
    }
  }
  fclose(in);
  
  //ől 1 ɃXP[O
  for(int i=0; i<num[2]; i++)
  for(int j=0; j<num[1]; j++)
  for(int k=0; k<num[0]; k++)
    vol[i][j][k] /= max;
}

float intensity(float x, float y, float z){
  x /= pitch[0];
  y /= pitch[1];
  z /= pitch[2];
  
  int ix = (int)x;
  if(ix < 0 || ix > num[0] -2)
    return -1;
  int iy = (int)y;
  if(iy < 0 || iy > num[1] -2)
    return -1;
  int iz = (int)z;
  if(iz < 0 || iz > num[2] -2)
    return -1;
  
  float dx = x - ix;
  float dy = y - iy;
  float dz = z - iz;
  
  //Od`
  float v00 = (1-dx)*vol[iz][iy][ix] + dx*vol[iz][iy][ix+1];
  float v01 = (1-dx)*vol[iz][iy+1][ix] + dx*vol[iz][iy+1][ix+1];
  float v10 = (1-dx)*vol[iz+1][iy][ix] + dx*vol[iz+1][iy][ix+1];
  float v11 = (1-dx)*vol[iz+1][iy+1][ix] + dx*vol[iz+1][iy+1][ix+1];
  
  float v0 = (1-dy)*v00 + dy*v01;
  float v1 = (1-dy)*v10 + dy*v11;
  
  return (1-dz)*v0 + dz*v1;
}

//gradient  @vZ
void normal(float n[3], float x, float y, float z){
  float gx = intensity(x+pitch[0], y, z) - intensity(x-pitch[0], y, z);
  float gy = intensity(x, y+pitch[1], z) - intensity(x, y-pitch[1], z);
  float gz = intensity(x, y, z+pitch[2]) - intensity(x, y, z-pitch[2]);
  float l = sqrt(gx*gx + gy*gy + gz*gz);
  if(l != 0){
    n[0] = gx/l;
    n[1] = gy/l;
    n[2] = gz/l;
  }
  else{
    n[0] = n[1] = n[2] = 0;
  }
}

//C}[`O̊֐ : n_ s   d ͂ @ n vZ
bool rayMarching(float n[3], float s[3], float d[3]){
  //{[S()Ƃ̌_vZ
  //eɐ2ʂ̊Ԃɂ̋ʕvZ
  float tmin = -10000; // s + t d ƂƎn_ t
  float tmax = 10000; //I_
  for(int i=0; i<3; i++){
    if(fabs(d[i]) < 0.001f){ //Cs̏ꍇ
      if(s[i] < 0 || num[i]*pitch[i] < s[i])
        return false;
    }
    else{
      float t0 = -s[i]/d[i];
      float t1 = (num[i]*pitch[i] - s[i])/d[i];
      if(t1 < t0){
        float t = t0;
        t0 = t1;
        t1 = t;
      }	  
      if(t1 < tmin || t0 > tmax)
        return false;
      if(tmin < t0)
        tmin = t0;
      if(tmax > t1)
        tmax = t1;
    }
  }
  
  float dt = DT*(pitch[0]+pitch[1]+pitch[2])/3.0f;
  float pa = 1;
  float v0 = 0;
  for(float t=tmin; t<tmax; t+=dt){
    float v = intensity(s[0]+t*d[0], s[1]+t*d[1], s[2]+t*d[2]);
    if(v > iso){
      t -= dt*fabs(v-iso)/(fabs(v0-iso)+fabs(v-iso));
      normal(n, s[0]+t*d[0], s[1]+t*d[1], s[2]+t*d[2]);
      return true;
    }
    v0 = v;
  }
  
  return false;
}

void generateImage(){
  //4]s
  float R11 = 1.0 - 2*(qy*qy + qz*qz);
  float R12 = 2*(qx*qy - qz*qw);
  float R13 = 2*(qx*qz + qy*qw);
  
  float R21 = 2*(qx*qy + qz*qw);
  float R22 = 1.0 - 2*(qz*qz + qx*qx);
  float R23 = 2*(qy*qz - qx*qw);
  
  float R31 = 2*(qx*qz - qy*qw);
  float R32 = 2*(qy*qz + qx*qw);
  float R33 = 1.0 - 2*(qx*qx + qy*qy);
  
  float l[3];
  l[0] = R11*light[0] + R12*light[1] + R13*light[2];
  l[1] = R21*light[0] + R22*light[1] + R23*light[2];
  l[2] = R31*light[0] + R32*light[1] + R33*light[2];
  
  int N = width;
  if(N > height)
    N = height;
  
  for(int i=0; i<height; i++){
    for(int j=0; j<width; j++){
      float s[3], d[3]; //C̎n_ƕ(PʃxNg)
      
      //WϊO̎n_ʒu
      float sx = pitch[0]*num[0]*(1.2*j/N-0.1);
      float sy = pitch[1]*num[1]*(1.2*i/N-0.1);
      float sz = -pitch[2]*num[2];
      
      //WϊO̕
      float dx = 0;
      float dy = 0;
      float dz = 1;
      
      //ϊ
      sx -= num[0]*pitch[0]*0.5;
      sy -= num[1]*pitch[1]*0.5;
      sz -= num[2]*pitch[2]*0.5;
      s[0] = zoom*(R11*sx + R12*sy + R13*sz);
      s[1] = zoom*(R21*sx + R22*sy + R23*sz);
      s[2] = zoom*(R31*sx + R32*sy + R33*sz);
      s[0] += num[0]*pitch[0]*0.5 - 100*shiftX;
      s[1] += num[1]*pitch[1]*0.5 + 100*shiftY;
      s[2] += num[2]*pitch[2]*0.5;
      
      d[0] = R11*dx + R12*dy + R13*dz;
      d[1] = R21*dx + R22*dy + R23*dz;
      d[2] = R31*dx + R32*dy + R33*dz;
      
      float n[3];
      float c[3];
      if(rayMarching(n, s, d)){
        //gÛ
        float dot = n[0]*l[0] + n[1]*l[1] + n[2]*l[2];
        c[0] = dot*color[0];
        c[1] = dot*color[1];
        c[2] = dot*color[2];
      }
      else{
        c[0] = bg[0];
        c[1] = bg[1];
        c[2] = bg[2];
      }
      
      //摜֒l
      int k = 3*(i*width+j);
      image[k  ] = (GLubyte)(c[0]*255);
      image[k+1] = (GLubyte)(c[1]*255);
      image[k+2] = (GLubyte)(c[2]*255);
    }
  }
}

void display(void){
  generateImage();

  //摜\
  glClear(GL_COLOR_BUFFER_BIT);
  glRasterPos2i(0, 0);
  glDrawPixels(width, height, GL_RGB,
               GL_UNSIGNED_BYTE, image);
  
  //XN[XV
  glFlush(); 
  glutSwapBuffers(); 
} 


void myinit(){
  glClearColor(0,0,0,0);
  glShadeModel(GL_FLAT);
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
}

void myReshape(int w, int h){
  if(image != NULL)
    delete[] image;
  image = new GLubyte[h*w*3];
  
  width = w;
  height = h;
  
  glViewport(0, 0, w, h); 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(0, w, 0, h, -1, 1);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
} 

void mouse(int btn, int state, int x, int y){ 
  /* mouse callback, selects an axis about which to rotate */
  if(state == GLUT_DOWN){
    mouseX = x;
    mouseY = y;
  }
  else if(btn==GLUT_LEFT_BUTTON){
    float mx = -0.0025f*(x - mouseX)/zoom;
    float my = 0.0025f*(y - mouseY)/zoom;
    
    //rotation
    float c = (float)cos(my);
    float s = (float)sin(my);
    
    float rw = c*qw - s*qx;
    float rx = c*qx + s*qw;
    float ry = c*qy - s*qz;
    float rz = c*qz + s*qy;
    
    c = (float)cos(mx);
    s = (float)sin(mx);
    
    qw = c*rw - s*ry;
    qx = c*rx + s*rz;
    qy = c*ry + s*rw;
    qz = c*rz - s*rx;
    
    float n = (float)sqrt(qw*qw + qx*qx + qy*qy + qz*qz);
    if(n != 0){
      qw /= n;
      qx /= n;
      qy /= n;
      qz /= n;
    }
    else{
      qw = 1.0f;
      qx = qy = qz = 0.0f;
    }
    display();
  }
  else if(btn==GLUT_RIGHT_BUTTON){
    zoom -= 0.0025f*(y - mouseY);
    if(zoom > 20.0f) zoom = 20.0f;
    else if(zoom < 0.05f) zoom = 0.05f;
    display();
  }
  else if(btn==GLUT_MIDDLE_BUTTON){
    shiftX += 0.0025f*(x - mouseX)/zoom;
    shiftY += 0.0025f*(y - mouseY)/zoom;
    display();
  }
}

void specialKeys(int key, int x, int y){
  switch (key) {
  case GLUT_KEY_DOWN:
    iso -= 0.05;
    printf("l %f\n", iso);
    display();
    break;
  case GLUT_KEY_UP:
    iso += 0.05;
    printf("l %f\n", iso);
    display();
    break;
  }
}

int main(int argc, char** argv){
  readVolume("data/tooth");
  
  image = NULL;
  
  //]Ȃǂ̏
  qw = 1;
  qx = qy =  qz = 0;
  zoom = 1;
  shiftX = shiftY = 0;
  
  //EBhȄ
  glutInit(&argc, argv); 
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB); //gpobt@̐ݒ
  glutInitWindowSize(300, 300); //EBhȆ傫
  glutCreateWindow("prog5-3"); //EBhẼ^Cg
  
  myinit(); //OpenGL ̏
  glutReshapeFunc(myReshape); //EBhETCYύXꂽɌĂ΂֐ݒ
  glutDisplayFunc(display);  //EBhE̍XV̂߂̊֐ݒ
  glutMouseFunc(mouse); //}EX삳ꂽƂɌĂ΂֐ݒ
  glutSpecialFunc(specialKeys);
  
  glutMainLoop(); //C[v
  
  return 0;
}

